%global macrosdir %(d=%{_rpmconfigdir}/macros.d; [ -d $d ] || d=%{_sysconfdir}/rpm; echo $d)

Name:           g2clib
Version:        1.6.3
Release:    1%{?dist}
Summary:        GRIB2 encoder/decoder and search/indexing routines in C

License:        LicenseRef-Fedora-Public-Domain
URL:            http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/
Source0:        http://www.nco.ncep.noaa.gov/pmb/codes/GRIB2/g2clib-%{version}.tar
Source1:        g2clib-msg.txt
Patch0:         g2clib-64bit.patch
Patch1:         g2clib-templates.patch
Patch2:         g2clib-simunpack.patch
Patch3:         g2clib-degrib.patch
Patch4:         g2clib-jasper2.patch
Patch5:         g2clib-1.6.3-jasper3-use-wrapper-entry-point.patch

BuildRequires:  make
BuildRequires:  gcc
BuildRequires:  libpng-devel jasper-devel

%global debug_package %{nil}

%if %{lua: print(rpm.vercmp(rpm.expand("%version"),"1.6.0"))} >= 0
%global g2clib g2c_v%{version}
%else
%global g2clib grib2c
%endif

%description
This library contains "C" decoder/encoder
routines for GRIB edition 2.  The user API for the GRIB2 routines
is described in ASCII file "grib2c.doc".


%package        devel
Summary:        Development files for %{name}
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
Requires:       jasper-devel
Requires:       libpng-devel

%description    devel
This library contains "C" decoder/encoder
routines for GRIB edition 2.  The user API for the GRIB2 routines
is described in file "grib2c.doc".

The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
%patch0 -p1 -b .64bit
%patch1 -p1 -b .templates
%patch2 -p1 -b .simunpack
%patch3 -p1 -b .degrib
%patch4 -p1 -b .jasper2
%patch5 -p1 -b .jasper3_internal
chmod a-x *.h *.c README CHANGES grib2c.doc makefile
cp -p %{SOURCE1} .


%build
CFLAGS="$RPM_OPT_FLAGS -DUSE_PNG -DUSE_JPEG2000"

%ifarch sparc64 s390x %{mips64}
CFLAGS="$CFLAGS -D__64BIT__ -fPIC"
%endif
%ifarch x86_64 ia64 %{power64} aarch64
CFLAGS="$CFLAGS -D__64BIT__ -fpic"
%endif
%ifarch %{ix86} %{arm} %{mips32}
CFLAGS="$CFLAGS -fpic"
%endif

make CFLAGS="$CFLAGS" CC="%{__cc}" ARFLAGS=


%install
mkdir -p %{buildroot}%{_libdir} %{buildroot}%{_includedir}
install -p -m0644 lib%{g2clib}.a %{buildroot}%{_libdir}
install -p -m0644 grib2.h %{buildroot}%{_includedir}
install -p -m0644 drstemplates.h %{buildroot}%{_includedir}
install -p -m0644 gridtemplates.h %{buildroot}%{_includedir}
install -p -m0644 pdstemplates.h %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{macrosdir}
echo %%g2clib %g2clib > %{buildroot}%{macrosdir}/macros.g2clib


%files devel
%doc README CHANGES grib2c.doc g2clib-msg.txt
%{_libdir}/lib%{g2clib}.a
%{_includedir}/grib2.h
%{_includedir}/drstemplates.h
%{_includedir}/gridtemplates.h
%{_includedir}/pdstemplates.h
%{macrosdir}/macros.g2clib


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.6.3-1
- initial build
